package jp.co.sds_corp.util.window;

import java.awt.Image;
import java.awt.image.BufferedImage;
import java.net.URL;

import javax.swing.ImageIcon;

/**
* 元の画像サイズと関係なく表示サイズを設定できるIconです。
* @author	小見山　聡
*/
public class SizedIcon extends ImageIcon
{
	/**
	* アイコンを指定されたファイルから読み込み、指定されたサイズで初期化します。
	* @param	file	アイコンを読み込むファイル
	* @param	nSize	アイコンのサイズ
	*/
	public SizedIcon( String file, int nSize ) {
		super( file );
		set( nSize );
	}

	/**
	* アイコンを指定されたURLから読み込み、指定されたサイズで初期化します。
	* @param	url		アイコンを読み込むURL
	* @param	nSize	アイコンのサイズ
	*/
	public SizedIcon( URL url, int nSize ) {
		super( url );
		set( nSize );
	}

	/**
	* アイコンを指定されたImageと、指定されたサイズで初期化します。
	* @param	image	アイコンのImage
	* @param	nSize	アイコンのサイズ
	*/
	public SizedIcon( Image image, int nSize ) {
		super( image );
		set( nSize );
	}

	int nSize = 0;
	private void set( int nSize ) {
		this.nSize = nSize;
//		Image i = c.createImage( nSize, nSize );
//		Image i = new BufferedImage( nSize, nSize, BufferedImage.TYPE_INT_RGB );
		Image i = new BufferedImage( nSize, nSize, BufferedImage.TYPE_4BYTE_ABGR );
		if ( i != null ) {
			i.getGraphics().drawImage( getImage(), 0, 0, nSize, nSize, getImageObserver() );
			setImage( i );
		}
	}
/*
	public void paintIcon( Component c, Graphics g, int x, int y ) {
		Image i = c.createImage( nSize, nSize );
		if ( i != null ) {
			i.getGraphics().drawImage( getImage(), 0, 0, nSize, nSize, c );
			setImage( i );
		}
	}
*/
}
